program depend
  use omp_lib
  implicit none
! This is the fixed version of depend.f90
  integer :: i
  real*8 :: g,x,sum=1.d0,pre(0:20)=1.d0,term
  write(*,*)' X = ?'; read(*,*)x
  sum=1.d0
  ! Fix: Pre-calculate pre in an array (serial)
  do i=1,20
     pre(i)=pre(i-1)/i
  end do
  ! Fix: Declare term private
  !$omp parallel do reduction(+:sum) private(term)
  do i=1,20
     term=g(x,i)
     sum=sum+pre(i)*term
     write(*,*)'nt=',omp_get_thread_num(),'i=',i,' pre=',pre(i),' term=',term
  end do
  !$omp end parallel do
  write(*,*)' Result =',sum
  stop
end program depend

real*8 function g(x,n)
! This function contains a call to sleep
! to simulate more time-consuming computations
  implicit none
  real*8, intent(in) :: x
  integer, intent(in) :: n
  g=x**n
  call sleep(1)
  return
end function g
