# 1 "minimum.f90"
# 1 "<built-in>"
# 1 "<command-line>"
# 1 "minimum.f90"
program minimum
  ! Picks out the smallest element of
  ! an array using omp_lock

  use omp_lib

  implicit none
  real*8, allocatable :: array(:)
  real*8 :: smallest=1.d0
  integer (kind=omp_lock_kind) :: mini
  integer :: i,n=10000000

  allocate(array(n))
  call random_number(array(:))

  call omp_init_lock(mini)
  !$omp parallel do
  do i=1,n

     if(array(i).lt.smallest) then
        !$omp flush (mini)
        call omp_set_lock(mini)

        if (array(i).lt.smallest) smallest=array(i)

        call omp_unset_lock(mini)
        !$omp flush (mini)
     end if

  end do
  !$omp end parallel do
  call omp_destroy_lock(mini)

  deallocate(array)
  write(*,*)' Smallest of ',n,'elements =',smallest
end program minimum
