! Example 2 of the course "Practical MPI for Novices".
! It shows that calculation can be parallelized.
! HPCVL, Queen's University, 2006

MODULE MPI
  INCLUDE 'mpif.h'
  INTEGER::MYID,TOTPS, IERR
END MODULE MPI


PROGRAM EXAMPLE02
  USE   MPI
  CALL  MPIINIT
  CALL  DEMO02
  CALL  MPI_FINALIZE(IERR)
  STOP
END PROGRAM EXAMPLE02


SUBROUTINE MPIINIT
  USE  MPI
  CALL MPI_INIT( IERR )
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYID,IERR)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,TOTPS,IERR)
  RETURN
END SUBROUTINE MPIINIT


SUBROUTINE DEMO02
  USE MPI
  USE OMP_LIB
  INTEGER:: M, I
  REAL*8 :: S, MYS
  IF(MYID.EQ.0) THEN
     WRITE(*,*)'How many terms?'
     READ(*,*) M
  END IF
  CALL MPI_BCAST(M,1,MPI_INTEGER,0, & 
                 MPI_COMM_WORLD,IERR)
  MYS=0.0D0
!$OMP PARALLEL DO PRIVATE(I) SHARED(MYID,M,TOTPS) REDUCTION(+:MYS)
  DO I=MYID,M,TOTPS
!    PRINT*,M,TOTPS,MYID,OMP_GET_NUM_THREADS(),OMP_GET_THREAD_NUM(),I
     MYS=MYS+DSQRT(DFLOAT(I))
  END DO
!$OMP END PARALLEL DO 
  WRITE(*,*)'RANK:', MYID,'MYS=',MYS,' M:',M
  S=0.0D0
  CALL MPI_REDUCE(MYS,S,1,MPI_REAL8,MPI_SUM, &
                       0, MPI_COMM_WORLD,IERR)
  IF(MYID.EQ.0) WRITE(*,*)'Total sum:  ', S
  RETURN
END SUBROUTINE DEMO02

