program sqroots
  ! Demonstrates the simple use of parallel
  ! regions on an array of square roots
  use omp_lib
  real*8, allocatable :: sqrs(:)
  real*8 :: sum
  integer :: nthr=1,ithr=0,sub,from,to,i
  read(*,*)m 
  allocate(sqrs(m))
!$omp parallel private(ithr,nthr,sub,from,to)
!$ nthr = omp_get_num_threads() 
!$ ithr = omp_get_thread_num()  
  sub = (m-1)/nthr +1
  from = ithr*sub+1; to = min(from+sub-1,m)
  do i=from,to ! i is private by default only in fortran
     sqrs(i)=sqrt(dfloat(i))
  end do
!$omp end parallel
  do i=1,m
     sum=sum+sqrs(i)
  end do
  deallocate(sqrs)
  write(*,*)' Result =',sum
end program sqroots
