program workload
  use omp_lib
  implicit none
  real :: random
  real*8 :: basetime=10.d0
  integer :: i,m
  integer, dimension(:), allocatable :: sleeptime
  write(*,*)' Give Number of Random Tasks:'
  read(*,*)m
  allocate(sleeptime(m))
  ! Creating a random sequence of tasks
  do i=1,m
     call random_number(random)
     sleeptime(i)=1+int(basetime*random)
  end do
  ! The actual execution of the 'work' is parallel
  !$omp parallel do schedule(runtime)
  do i=1,m
     write(*,*)&
          ' Task #',i,&
          ' Thread ',omp_get_thread_num(),&
          ' is sleeping for ',sleeptime(i),' seconds'
     call sleep(sleeptime(i))
  end do
  !$omp end parallel do
  stop
end program workload
